package gg.malloc.defense.commands;

import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabExecutor;
import org.bukkit.World;

import gg.malloc.defense.engine.GameRunner;

import gg.malloc.defense.Plugin;

import java.util.ArrayList;
import java.util.List;

public class SetStageCommand implements TabExecutor {
  Plugin m_plugin;

  public SetStageCommand(Plugin plugin) {
    m_plugin = plugin;
  }

  public List<String> onTabComplete(CommandSender sender, Command command, String label, String[] args) {
    ArrayList<String> ret = new ArrayList<>();
    if (args.length == 1) {
      String proposal = args[0];
      for(String arena : m_plugin.arenaNames()) {
        if (proposal.startsWith(arena)) {
          ret.add(arena);
        }
      }
    } else if (args.length == 2) {
      String proposal = args[1].toLowerCase();
      GameRunner.Stage stages[] = GameRunner.Stage.Idle.getDeclaringClass().getEnumConstants();
      for(GameRunner.Stage stage : stages) {
        if (proposal.startsWith(stage.toString().toLowerCase())) {
          ret.add(stage.toString());
        }
      }
    }
    return ret;
  }

  @Override
  public boolean onCommand(CommandSender sender, Command command, String s, String[] args) {
    if (args.length != 2) {
      sender.sendMessage("Usage: setstage <stage> <arena>");
      return true;
    }
    GameRunner runner = m_plugin.getRunnerForArenaName(args[1]);
    if (runner == null) {
      sender.sendMessage("Unknown arena " + args[1]);
      return true;
    }
    String stateName = args[0].toLowerCase();
    boolean ret = false;
    GameRunner.Stage decodedStage = null;
    GameRunner.Stage stages[] = GameRunner.Stage.Idle.getDeclaringClass().getEnumConstants();
    for(GameRunner.Stage stage : stages) {
      if (stage.toString().toLowerCase().equals(stateName)) {
        decodedStage = stage;
        break;
      }
    }
    if (decodedStage != null) {
      sender.sendMessage("Requesting transition to " + decodedStage);
      if (!runner.requestTransition(decodedStage)) {
        sender.sendMessage("Could not transition to " + decodedStage);
        return false;
      }
      return true;
    } else {
      sender.sendMessage("Unknown state " + stateName);
      return false;
    }
  }
}
